<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_hospital".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderHospital".
 *
 * Columns in table "provider_hospital" available as properties of the model,
 * followed by relations of table "provider_hospital" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $hospital_id
 *
 * @property Hospital $hospital
 * @property Provider $provider
 */
abstract class BaseProviderHospital extends BaseModel
{

    /**
     * This var is used to hold CONCAT(p.prefix, ' ', p.first_name, ' ', p.last_name, ' at ', p2.name)
     * AS provider_at_hospital
     * @see hospitalSchedule.php #31
     * @var string
     */
    public $provider_at_hospital;

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_hospital';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('provider_id, practice_id', 'required'),
            array('provider_id, practice_id', 'numerical', 'integerOnly' => true),
            array('id, provider_id, practice_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'practice_id' => Yii::t('app', 'Hospital'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.first_last", $this->provider_id);
        } else {
            $criteria->compare('provider_id', $this->provider_id);
        }

        if (!intval($this->practice_id) && is_string($this->practice_id) && strlen($this->practice_id) > 0) {
            $criteria->with[] = 'practice';
            $criteria->addSearchCondition("practice.name", $this->practice_id);
        } else {
            $criteria->compare('practice_id', $this->practice_id);
        }

        return new CActiveDataProvider(get_class($this), array('criteria' => $criteria,
            'pagination' => array('pageSize' => 100)));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderHospital|ProviderHospitals', $n);
    }

}
